[libcamera-devel] [PATCH v3] v4l2: Provide libcamerify wrapper script
Kieran Bingham
kieran.bingham at ideasonboard.com
Tue Feb 1 18:12:41 CET 2022
Support easier usage of the v4l2 compatibility layer with a script that
handles the LD_PRELOAD for applications.
The wrapper can be prefixed to launch any application with the preload
set:
$ libcamera-v4l2 v4l2-ctl --list-devices
\_SB_.PCI0.GP13.XHC0.RHUB.PRT4- (libcamera:0):
/dev/video0
platform/vimc.0 Sensor B (libcamera:1):
/dev/video2
/dev/video3
/dev/video4
Specifying '-d' once before the command to run will enable V4L2Compat
layer debug output from libcamera.
Specifying '-d' twice will enable all debug levels from all libcamera
components and provide a very detailed log for analysis.
Signed-off-by: Kieran Bingham <kieran.bingham at ideasonboard.com>
---
v3:
- Export LD_PRELOAD last.
- Fix up options parsing style
- Exit 1 on failure, exit 0 on help.
- Add license.
src/v4l2/libcamerify.in | 47 +++++++++++++++++++++++++++++++++++++++++
src/v4l2/meson.build | 14 ++++++++++++
2 files changed, 61 insertions(+)
create mode 100755 src/v4l2/libcamerify.in
diff --git a/src/v4l2/libcamerify.in b/src/v4l2/libcamerify.in
new file mode 100755
index 000000000000..c4ea273fa627
--- /dev/null
+++ b/src/v4l2/libcamerify.in
@@ -0,0 +1,47 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-or-later
+
+help() {
+ echo "$0: Load an application with libcamera V4L2 compatibility layer preload"
+ echo " $0 [OPTIONS...] executable [args]"
+ echo " -d, --debug Increase log level"
+}
+
+debug=0
+while [ $# -gt 0 ]; do
+ case $1 in
+ -d|--debug)
+ debug=$((debug+1))
+ ;;
+ -h)
+ help;
+ exit 0
+ ;;
+ --)
+ shift;
+ break;;
+ -*)
+ echo "Unrecognised option: $1";
+ help;
+ exit 1
+ ;;
+ *)
+ break
+ ;;
+ esac
+ shift
+done
+
+[ $debug -gt 0 ] && loglevel=V4L2Compat:0
+[ $debug -gt 1 ] && loglevel=0
+[ "$loglevel" != "" ] && export LIBCAMERA_LOG_LEVELS=$loglevel
+
+if [ "$LD_PRELOAD" = "" ] ; then
+ LD_PRELOAD='@LIBCAMERA_V4L2_SO@'
+else
+ LD_PRELOAD="$LD_PRELOAD "'@LIBCAMERA_V4L2_SO@'
+fi
+
+export LD_PRELOAD
+
+exec "$@"
diff --git a/src/v4l2/meson.build b/src/v4l2/meson.build
index f78497b6799b..07ff9a6939d2 100644
--- a/src/v4l2/meson.build
+++ b/src/v4l2/meson.build
@@ -33,3 +33,17 @@ v4l2_compat = shared_library('v4l2-compat',
install : true,
dependencies : [libcamera_private, libdl],
cpp_args : v4l2_compat_cpp_args)
+
+# Provide a wrapper script to support easily loading applications with the V4L2
+# adaptation layer
+
+config_h.set('LIBCAMERA_V4L2_SO', get_option('prefix') / get_option('libdir') / 'v4l2-compat.so')
+
+summary({
+ 'LIBCAMERA_V4L2_SO' : config_h.get('LIBCAMERA_V4L2_SO'),
+}, section : 'Paths')
+
+configure_file(input : 'libcamerify.in',
+ output : 'libcamerify',
+ configuration : config_h,
+ install_dir : get_option('bindir'))
--
2.32.0
More information about the libcamera-devel
mailing list